angular.module('tribe.controllers', ['CustomFilter'])

  .controller('FacebookloginCtrl', function ($scope, FacebookService) {
    $scope.facebookSignIn = function () {
      FacebookService.login();
    };
  })

  .controller('AppCtrl', function ($scope, $ionicModal) {

    //$scope.showSettings = true;
    //$rootScope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams) {
    //  $scope.showSettings = $state.is('app.tabbed.curated') || $state.is('app.tabbed.discover');
    //});

  })

  .controller('TabbedCtrl', function ($scope, $rootScope, $state) {

    var tabs = ['app.tabbed.curated', 'app.tabbed.discover', 'app.tabbed.myTribe'];
    var themes = ['red','orange','yellow'];

    $scope.goTo = function(state) {
      $state.go(state);
    };
    // Change state when slide moves
    //$scope.onSlideMove = function (data) {
    //  $state.go(tabs[data.index]);
    //  $rootScope.theme = themes[data.index];
    //};

  })

  .controller('CuratedCtrl', function ($scope, $ionicModal, $ImageCacheFactory, TribeService, SettingService, $analytics) {

    //Analytics
    //$analytics.pageTrack('/curated/');
    $analytics.eventTrack('Curated');

    // Cache event images
    TribeService.getEvents(null, false, false).then(function (events) {
      var imageUrls = [];
      for (var i in events) {
        var image_url = events[i].primary_image_url;
        if (image_url)
          imageUrls.push(image_url);
      }
      console.log('caching images');
      $ImageCacheFactory.Cache(imageUrls).then(function(){
        console.log("Images done loading!");
      },function(failed){
        console.log("An image failed: "+failed);
      });
    });
    // Cache category images
    TribeService.getCategories().then(function(categories) {
      var urls = [];
      for (var i in categories) {
        var url = categories[i].thumbnail_url;
        if (url) urls.push(url);
      }
      $ImageCacheFactory.Cache(urls);
    });


    TribeService.getCategories().then(function (data) {
      $scope.categories = data;
    });
    loadEvents();

    $scope.refresh = loadEvents;

    $scope.$on('$ionicView.enter', function(){
      console.log('$ionicView.enter');
      loadEvents();
    });

    function loadEvents() {
      console.log('load events in Curated');
      TribeService.getEvents(null, false).then(function (data) {
        $scope.events = data;
        $scope.$broadcast('scroll.refreshComplete');
      });
    }

    $scope.dotdotdot = function() {
      $('.event-title').dotdotdot({wrap: 'letter'});
    }

    $scope.$on('SettingsChanged', loadEvents);
    $scope.$on('AddedToMyTribe', loadEvents);
    $scope.$on('RemovedFromMyTribe', loadEvents);

    $scope.closeModal = function() {
      $scope.modal.hide();
    };

    if (SettingService.getTutorial('curated-introduction')) {
      $ionicModal.fromTemplateUrl('info-modal.html', {
        scope: $scope,
        animation: 'fade-in-scale'
      }).then(function (modal) {
        $scope.modal = modal;
        $scope.modal.show();
      });
      SettingService.setTutorial('curated-introduction', false)
    }

  })

  .controller('EventItemCtrl', function($scope, $rootScope, $http, $cordovaLocalNotification, $ionicModal, $state, UserService, SettingService, TribeService, $analytics) {

    $scope.user = UserService.getUser();
    $scope.isInterested = $scope.user.interested_events && ($scope.user.interested_events.indexOf($scope.event.id) > -1);
    $scope.event.start_at_str = moment($scope.event.start_at_unix*1000).format('h.mma, Do MMMM YYYY')

    $scope.setInterested = function () {

      //Analytics
      $analytics.eventTrack('Interest added: ' + $scope.event.title);

      if ($scope.user && $scope.user.interested_events.indexOf($scope.event.id) > -1) {

        $ionicModal.fromTemplateUrl('confirm-modal.html', {
          scope: $scope,
          animation: 'fade-in-scale'
        }).then(function (modal) {
          $scope.modal = modal;
          $scope.modal.show();
          var modalEl = $('.tribe-modal.tutorial');
          var keenBtn = $('.keen-icon-' + $scope.event.id + ':visible');
          console.log(modalEl, keenBtn, keenBtn.offset());
          modalEl.css('top', keenBtn.offset().top - 100);
          modalEl.css('left', keenBtn.offset().left - 145);
        });

      } else {

        // Show tutorial
        if (SettingService.getTutorial('curated-addToMyTribe')) {
          $ionicModal.fromTemplateUrl('tutorial-modal.html', {
            scope: $scope,
            animation: 'fade-in-scale'
          }).then(function (modal) {
            $scope.modal = modal;
            $scope.modal.show();
            var modalEl = $('.tribe-modal.tutorial');
            var keenBtn = $('.keen-icon-' + $scope.event.id + ':visible');
            modalEl.css('top', keenBtn.offset().top - ($('#event-details-page').length > 0 ? 174 : 57));
          });
          SettingService.setTutorial('curated-addToMyTribe', false); // don't show this tutorial anymore
        }

        TribeService.addToMyTribe($scope.event);
        $scope.isInterested = true;
      }
    };

    $scope.confirmRemove = function() {
      //Analytics
      $analytics.eventTrack('Interest removed: ' + $scope.event.title);

      TribeService.removeFromMyTribe($scope.event);
      $scope.isInterested = false;
      $scope.modal.hide();
    };

    $scope.closeModal = function() {
      $scope.modal.hide();
    }

  })

  .controller('DiscoverCtrl', function ($scope, $ionicModal, TribeService, SettingService, $analytics) {

    //Analytics
    $analytics.eventTrack('Discover');

    function loadCategories() {
      TribeService.getCategories().then(function (categories) {
        var params = {
          age: SettingService.get('age'),
          city: SettingService.get('city')
        };
        TribeService.getEvents(params, false, false).then(function (events) {
          for (var catId in categories) {
            categories[catId].event_count = 0;
          }
          for (var eventId in events) {
            for (var i in events[eventId].category_ids) {
              var catId = events[eventId].category_ids[i];
              categories[catId].event_count++;
            }
          }
          $scope.categories = categories;
        });
      });
    }

    loadCategories();
    $scope.$on('SettingsChanged', loadCategories);

    $scope.closeModal = function() {
      $scope.modal.hide();
    };

    if (SettingService.getTutorial('discover-introduction')) {
      $ionicModal.fromTemplateUrl('info-modal.html', {
        scope: $scope,
        animation: 'fade-in-scale'
      }).then(function (modal) {
        $scope.modal = modal;
        $scope.modal.show();
      });
      SettingService.setTutorial('discover-introduction', false)
    }

  })

  .controller('CategoryCtrl', function ($scope, $stateParams, TribeService, SettingService, $analytics) {

    function loadCategories() {
      TribeService.getCategory($stateParams.id).then(function (category) {
        $scope.category = category;

        //Analytics
        $analytics.eventTrack('Category: ' + category.name);

        var params = {
          age: SettingService.get('age'),
          city: SettingService.get('city'),
          friends: SettingService.get('friends'),
        };

        TribeService.getEvents(params, false, false).then(function (events) {
          $scope.events = {};
          for (var eventId in events) {
            if (events[eventId].category_ids.indexOf($scope.category.id) != -1) {
              $scope.events[eventId] = events[eventId];
            }
          }
        });
      });
    }

    loadCategories();
    //$scope.$on('SettingsChanged', loadCategories);

    $scope.dotdotdot = function() {
      $('.event-title').dotdotdot({wrap: 'letter'});
    };
  })

  .controller('MyTribeCtrl', function ($scope, $ionicModal, TribeService, UserService, SettingService, $analytics) {
    //Analytics
    $analytics.eventTrack('My Tribe');

    TribeService.getCategories().then(function (data) {
      $scope.categories = data;
    });

    function loadEvents() {
      console.log('load events in My Tribe');
      var user = UserService.getUser();
      TribeService.getEvents({
        userId: user.id,
        friends: SettingService.get('friends'),
      }, false).then(function (data) {
        $scope.events = data;
        $scope.$broadcast('scroll.refreshComplete');
      });
    }
    loadEvents();
    $scope.refresh = loadEvents;
    $scope.$on('SettingsChanged', loadEvents);
    $scope.$on('AddedToMyTribe', loadEvents);
    $scope.$on('RemovedFromMyTribe', loadEvents);

    $scope.dotdotdot = function() {
      $('.event-title').dotdotdot({wrap: 'letter'});
    }

    $scope.closeModal = function() {
      $scope.modal.hide();
    };
    if (SettingService.getTutorial('mytribe-introduction')) {
      $ionicModal.fromTemplateUrl('info-modal.html', {
        scope: $scope,
        animation: 'fade-in-scale'
      }).then(function (modal) {
        $scope.modal = modal;
        $scope.modal.show();
      });
      SettingService.setTutorial('mytribe-introduction', false)
    }
  })

  .controller('EventDetailsCtrl', function ($scope, $rootScope, $stateParams, $state, $cordovaCalendar, $controller, $ionicModal, TribeService, UserService, SettingService, $analytics) {

    if ($state.is('app.tabbed.curatedEvent'))  $scope.galleryState = 'app.tabbed.curatedGallery({id:event.id})';
    if ($state.is('app.tabbed.discoverEvent')) $scope.galleryState = 'app.tabbed.discoverGallery({id:event.id})';
    if ($state.is('app.tabbed.myTribeEvent'))  $scope.galleryState = 'app.tabbed.myTribeGallery({id:event.id})';

    TribeService.getEvent($stateParams.id).then(function (event) {
      console.log('event data', event);

      //Analytics
      $analytics.eventTrack('Event: ' + event.title);

      $scope.event = event;
      if (event.price == '1') {
        $scope.event.priceText = '$' + event.min_price;
        if (event.max_price != event.min_price) {
          $scope.event.priceText += '-' + event.max_price;
          if (event.max_price == 120) {
            $scope.event.priceText += '+';
          }
        }
      } else {
        $scope.event.priceText = 'Free';
      }
      var start_at_moment = moment($scope.event.start_at_unix*1000);
      $scope.event.start_date = start_at_moment.format('ddd D MMM, YYYY');
      $scope.event.start_time = start_at_moment.format('h:mm a');

      $scope.user = UserService.getUser();
      $scope.isInterested = $scope.user.interested_events && ($scope.user.interested_events.indexOf($scope.event.id) > -1);

      //var calendarEvent = window.plugins.calendar.findEvent($scope.event.title, null, null, null, null,
      //  function() {
      //    console.log('find event success');
      //  }, function() {
      //    console.log('find event error');
      //  });
      //console.log('calendarEvent', JSON.stringify(calendarEvent));
      $scope.event.addedToCal = SettingService.getAddedToCalendar($scope.event.id);

      // Show tutorial
      //if (SettingService.getTutorial('eventDetails-addToMyTribe')) {
      //  $ionicModal.fromTemplateUrl('tutorial-modal.html', {
      //    scope: $scope,
      //    animation: 'fade-in-scale'
      //  }).then(function (modal) {
      //    setTimeout(function () {
      //      $scope.modal = modal;
      //      $scope.modal.show().then(function () {
      //        var modalEl = $('.tribe-modal.tutorial');
      //        var keenBtn = $('.btn-interested');
      //        modalEl.css('top', keenBtn.offset().top - 174);
      //      });
      //    }, 3000);
      //  });
      //  SettingService.setTutorial('eventDetails-addToMyTribe', false);
      //}

      // Inherit methods from EventItemCtrl
      $controller('EventItemCtrl', {$scope: $scope});
    });

    $scope.closeModal = function() {
      $scope.modal.hide();
    };

    $scope.openGallery = function() {
      $ionicModal.fromTemplateUrl('gallery-modal.html', {
        scope: $scope,
        animation: 'fade-in-scale'
      }).then(function (modal) {
        $scope.modal = modal;
        $scope.modal.show();
      });
    };

    TribeService.getCategories().then(function (data) {
      $scope.categories = data;
    });

    $scope.shareEvent = function (event) {
      if (window.plugins && window.plugins.socialsharing) {
        var image_url = event.primary_image_url ? event.primary_image_url.replace(/ /g, '%20') : null;
        console.log('image_url', image_url);
        window.plugins.socialsharing.share("Check out this event I discovered via Tribe: " + event.title + "\n\n" ,
          'Tribe', image_url, event.url,
          function () {
            console.log("Success")

            //Analytics
            $analytics.eventTrack('Shared: ' + event.title);

          },
          function (error) {
            console.log("Share fail " + error)
          });
      }
      else console.log("Share plugin not available");
    };

    $scope.addToCalendar = function (event) {
      if (window.plugins && window.plugins.calendar && !event.addedToCal) {
        // Request permission
        window.plugins.calendar.hasReadWritePermission(
          function(result) {
            console.log('result', result);
            if (!result)
              window.plugins.calendar.requestReadWritePermission();
          }
        );

        var calOptions = window.plugins.calendar.getCalendarOptions();
        calOptions.url = event.url;
        calOptions.firstReminderMinutes = 120;
        var start_date = moment(event.start_at_unix*1000).toDate(),
            end_date = (event.end_at_unix && event.end_at_unix > event.start_at_unix) ? moment(event.end_at_unix*1000).toDate() : start_date;
        console.log('dates', start_date, end_date);
        window.plugins.calendar.createEventWithOptions(event.title, event.address, null,
          start_date,
          end_date,
          calOptions,
          function () {
            event.addedToCal = true;
            SettingService.setAddedToCalendar(event.id);
            $scope.$apply();
            console.log("Add to calendar Success");

            //Analytics
            $analytics.eventTrack('Added to Calendar: ' + event.title);

          },
          function (error) {
            console.log("Add to calendar fail " + error);
          });
      }
      else console.log("Cannot add to Calendar");
    }

    $scope.tellMeMore = function(url) {
      SafariViewController.isAvailable(function (available) {
        if (available) {
          SafariViewController.show({
              url: url,
              hidden: false, // default false. You can use this to load cookies etc in the background (see issue #1 for details).
              animated: false, // default true, note that 'hide' will reuse this preference (the 'Done' button will always animate though)
              transition: 'curl', // unless animated is false you can choose from: curl, flip, fade, slide (default)
              enterReaderModeIfAvailable: readerMode, // default false
              tintColor: "#ff0000" // default is ios blue
            },
            // this success handler will be invoked for the lifecycle events 'opened', 'loaded' and 'closed'
            function(result) {
              console.log('SafariViewController event', result.event);

              //Analytics
              $analytics.eventTrack('Tell me More: ' + event.title);

            },
            function(msg) {
              console.log("SafariViewController KO: " + msg);
            })
        } else {
          // potentially powered by InAppBrowser because that (currently) clobbers window.open
          window.open(url, '_blank', 'location=no');
        }
      });
    }

  })

  .controller('GalleryCtrl', function($scope, $stateParams, TribeService) {

    $scope.items = [];
    TribeService.getEvents().then(function (data) {
      var event = data[$stateParams.id];
      // Add items to photo gallery
      for (var i in event.images) {
        $scope.items.push({
          src: event.images[i].image_url
        });
      }
    });

  })

  .controller('SettingsCtrl', function ($scope, TribeService, UserService, SettingService, FacebookService, $ionicActionSheet, $state, $rootScope, $analytics) {

    //Analytics
    $analytics.eventTrack('Settings');

    $scope.citySettingState = $state.is('app.tabbed.curated-settings') ? 'app.tabbed.curated-settings-city' : 'app.tabbed.discover-settings-city';

    TribeService.getCategories().then(function (data) {
      $scope.categories = data;
      console.log('settings category:', data);
      //angular.element(document).find('.back-button').removeClass('hide');
    });
    $scope.user = UserService.getUser();
    $scope.settings = SettingService.get();
    if (Object.keys($scope.settings.category).length == 0) {
      TribeService.getCategories().then(function(categories) {
        for (var i in categories) {
          $scope.settings.category[i] = true;
        }
      });
    }

    $scope.saveSettings = function() {
      SettingService.set($scope.settings);
    };

    $scope.showLogOutMenu = function() {
      var hideSheet = $ionicActionSheet.show({
        destructiveText: 'Logout',
        titleText: 'Are you sure you want to logout?',
        cancelText: 'Cancel',
        cancel: function() {
        },
        buttonClicked: function (index) {
          return true;
        },
        destructiveButtonClicked: function () {
          FacebookService.logout();
        }
      });
    };

    $scope.$on('$ionicView.beforeLeave', function(){
      console.log('applying settings');
      $rootScope.$broadcast('SettingsChanged');
    });
  })

  .controller('CitySettingsCtrl', function ($scope, TribeService, SettingService) {

    TribeService.getStates().then(function(data) {
      $scope.states = data;
    });
    $scope.settings = SettingService.get();
    $scope.selected = $scope.settings.city;

    $scope.select = function(state) {
      $scope.selected = state.city;
      $scope.settings.city = state.city;
      SettingService.set($scope.settings);
    };

  })

  .directive('hideTabs', function($rootScope) {
    return {
      restrict: 'A',
      link: function($scope, $el) {
        $rootScope.hideTabs = 'tabs-item-hide';
        $scope.$on('$destroy', function() {
          $rootScope.hideTabs = '';
        });
      }
    };
  });

;
